using System;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;


class TestInfoMessage
{
	private const string CONNECTION_STRING = "Server=.; " +
		"Database=Pubs; Integrated Security=true";
	private SqlConnection mConn;

	public static void Main()
	{
		TestInfoMessage test = new TestInfoMessage();
		try
		{
			test.InitConnection();
			SqlCommand cmd = new SqlCommand(
				"RAISERROR('Test error message', 6, 1)", test.mConn);
			cmd.ExecuteNonQuery();
		}
		catch(Exception){}
		finally
		{
			test.mConn.Close();
		}
	}
	
	private void InitConnection()
	{
		mConn = new SqlConnection(CONNECTION_STRING);
		mConn.InfoMessage +=
			new SqlInfoMessageEventHandler(ConnInfoMessage);
		mConn.Open();
	}
	
	private void ConnInfoMessage(object sender, 
		SqlInfoMessageEventArgs e)
	{
		Debug.WriteLine("SQL Server message: " + 
			e.Message + "   Source: " + e.Source);
	}
}