using System;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;

class TestStateChange
{
	private const string CONNECTION_STRING = "Server=.;" +
		" Database=Pubs; Integrated Security=true";

	private SqlConnection mConn;
	
	public static void Main()
	{
		TestStateChange test = new TestStateChange();
		
		try
		{
			test.InitConnection();
			
		}
		catch(Exception){}
		finally
		{
			test.mConn.Close();
		}
	}
	
	private void InitConnection()
	{
		mConn = new SqlConnection(CONNECTION_STRING);
		mConn.StateChange += 
			new StateChangeEventHandler(ConnStateChange);
		mConn.Open();
	}

	private void ConnStateChange(object sender,
		StateChangeEventArgs e)
	{
		Debug.WriteLine("SQL Server connection: " +
			e.OriginalState.ToString() + " --> " +
			e.CurrentState.ToString());
	}
}
