using System;
using System.Data;
using System.Data.OleDb;

class OleDbConnectionDemo
{
	const string MS_ACCESSS_GENERIC_CONNECTION_STRING =
		@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0};Persist Security Info=False";

	static void Main()
	{
		string connectionString = string.Format(
			MS_ACCESSS_GENERIC_CONNECTION_STRING, @"C:\Library.mdb");

		OleDbConnection dbConn = new OleDbConnection(connectionString);
			
		// Open connection
		dbConn.Open();
		OleDbTransaction dbTran = dbConn.BeginTransaction();
		using (dbConn)
		{
			OleDbCommand cmd = new OleDbCommand(
				"INSERT INTO Users ([username], [password]) VALUES (@user, @pass)", dbConn);
		
			cmd.Transaction = dbTran;
			cmd.Parameters.Add("@user", OleDbType.VarChar).Value = "new user name";
			cmd.Parameters.Add("@pass", OleDbType.VarChar).Value = "secret password";
			
			// Execute command
			try
			{
				int rowsAffected = cmd.ExecuteNonQuery();
			
				cmd.Parameters["@user"].Value = "tooooooooooooooooooooooooooooooooooo long user name";
				rowsAffected = cmd.ExecuteNonQuery();
				
				dbTran.Commit();
				Console.WriteLine("Operation was successfull.");
				System.Threading.Thread.CurrentThread.Suspend();
			}
			catch (OleDbException)
			{
				dbTran.Rollback();
				Console.WriteLine("SQL Error occured!");
			}
		}
	}
}