ALTER PROCEDURE dbo.sp_SelectShippedOrdersByShipper
(
	@ShipperCompany nvarchar(40)
)
AS
    DECLARE @ShipperId int

    SET @ShipperId =
        (SELECT ShipperID
         FROM Shippers
         WHERE CompanyName=@ShipperCompany)
	
    IF @ShipperId IS NULL
    BEGIN
        RAISERROR ('Invalid shipping company!', 16, 1)
        RETURN
    END

    SELECT * 
    FROM Orders
    WHERE ShipVia=@ShipperId
    
	RETURN
