-- Create database TestDML
USE master
CREATE DATABASE TestDML
GO


-- Create table Users in the TestDML table
USE TestDML
CREATE TABLE Users
(
	UserID int identity NOT NULL, -- PRIMARY KEY
	FirstName nvarchar(50),
	LastName nvarchar(50),
	Email varchar(50),
	Phone varchar(20),
)
GO


-- Insert several records in the table Users
use TestDML
INSERT INTO Users (FirstName, LastName, Email)
VALUES ('Branimir', 'Giurov', 'branimir@nospam.bg')

INSERT INTO Users (FirstName, LastName, Phone, Email)
VALUES ('Svetlin', 'Nakov', '+359 2 123456789', 'see www.nakov.com')

INSERT INTO Users (FirstName, LastName)
VALUES ('Stephan', 'Zahariev')
GO


-- Performs some SELECT queries
USE TestDML
GO

SELECT * FROM Users

SELECT * FROM Users
ORDER BY LastName DESC

SELECT * FROM Users
WHERE Phone IS NOT NULL
GO


-- Performs some UPDATE commands
USE TestDML
GO

UPDATE Users
SET Email = 'stephan.zahariev@nospam.gmail.com'
WHERE FirstName = 'Stephan' and LastName = 'Zahariev'

-- View the updated table Users
SELECT * FROM Users

UPDATE Users
SET 
	FirstName = UPPER(FirstName), 
	LastName = UPPER(LastName)

-- View the updated table Users
SELECT * FROM Users
GO


-- Performs some DELETE commands
USE TestDML
GO

DELETE FROM Users
WHERE FirstName LIKE 'B%';

-- View the updated table Users
SELECT * FROM Users

DELETE FROM Users
WHERE UserID < 3;

-- View the updated table Users
SELECT * FROM Users
GO


-- Remove the database TestDML
USE master
DROP DATABASE TestDML
GO
