USE master
GO

CREATE DATABASE TestTransactions
GO

USE TestTransactions
GO

CREATE TABLE Users
(
    UserId bigint not null identity primary key,
    UserName varchar(50) not null unique,
    UserPassHash varchar(50)
)

CREATE TABLE Groups
(
    GroupId bigint not null identity primary key,
    GroupName varchar(50) not null unique
)

CREATE TABLE UsersGroups
(
    Id bigint not null identity primary key,
    UserId bigint not null,
    GroupId bigint not null
)

ALTER TABLE UsersGroups ADD
CONSTRAINT FK_UsersGroups_Groups FOREIGN KEY (GroupId) REFERENCES Groups (GroupId),
CONSTRAINT FK_UsersGroups_Users FOREIGN KEY (UserId) REFERENCES Users (UserId)
GO


INSERT INTO Groups (GroupName) VALUES ('Guests')
GO

CREATE PROCEDURE sp_InsertUser
(
    @userName varchar(50),
    @userPassHash varchar(50),
    @groupId bigint
)
AS
    BEGIN TRAN

    INSERT INTO Users (UserName, UserPassHash)
    VALUES (@userName, @userPassHash)

    IF (@@error = 0)
        INSERT UsersGroups (UserId, GroupId)
        VALUES (@@identity, @groupId)

    IF (@@error = 0)
        COMMIT TRAN
    ELSE
        ROLLBACK TRAN
GO


EXEC sp_InsertUser 'testuser', 'xxxxx', 1
GO
